require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/labels/configs', type: :request do
  let(:valid_attributes) { {name: 'Config1'} }
  let(:invalid_attributes) { {name: nil} }

  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  before :each do
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
    user.save!

    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Labels::Config.create! valid_attributes
      get labels_configs_url
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      labels_config = Labels::Config.create! valid_attributes
      get labels_config_url(labels_config)
      expect(response).to be_successful
    end
  end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_labels_config_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      labels_config = Labels::Config.create! valid_attributes
      get edit_labels_config_url(labels_config)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Labels::Config' do
        expect {
          post labels_configs_url, params: { labels_config: valid_attributes }
        }.to change(Labels::Config, :count).by(1)
      end

      it 'redirects to the created labels_config' do
        post labels_configs_url, params: { labels_config: valid_attributes }
        expect(response).to redirect_to(edit_labels_config_path(@controller.instance_variable_get(:@labels_config)))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Labels::Config' do
        expect {
          post labels_configs_url, params: { labels_config: invalid_attributes }
        }.to change(Labels::Config, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post labels_configs_url, params: { labels_config: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { { name: 'Config new name'} }

      it 'updates the requested labels_config' do
        labels_config = Labels::Config.create! valid_attributes
        patch labels_config_url(labels_config), params: { labels_config: new_attributes }
        labels_config.reload

        expect(labels_config.name).to eq('Config new name')
      end

      it 'redirects to the labels_config' do
        labels_config = Labels::Config.create! valid_attributes
        patch labels_config_url(labels_config), params: { labels_config: new_attributes }
        labels_config.reload
        expect(response).to redirect_to(labels_configs_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        labels_config = Labels::Config.create! valid_attributes
        patch labels_config_url(labels_config), params: { labels_config: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested labels_config' do
      labels_config = Labels::Config.create! valid_attributes
      expect {
        delete labels_config_url(labels_config)
      }.to change(Labels::Config, :count).by(-1)
    end

    it 'redirects to the labels_configs list' do
      labels_config = Labels::Config.create! valid_attributes
      delete labels_config_url(labels_config)
      expect(response).to redirect_to(labels_configs_url)
    end
  end
end
